<?php
/**
 * File:   Addtodefaultcategory.php
 * Author: Ernesto Minicone (napoli1890)
 * Date:   15/06/17
 * Time:   16.27
 */

namespace FiloBlu\Flow\Model\Actions\From;


use Magento\Backend\Block\System\Store\Store;
use Magento\TestFramework\Event\Magento;

class Addtodefaultcategory extends Addtocategory
{

    protected $_storemanager;

    public function __construct(
        \Magento\Framework\Model\Context $context,
        \Magento\Framework\Registry $registry,
        \FiloBlu\Flow\Helper\Product $helper_product,
        \FiloBlu\Flow\Helper\LoggerProvider $loggerProvider,
        \Magento\Catalog\Model\CategoryFactory $categoryFactory,
        \Magento\Catalog\Model\ProductFactory $productFactory,
        \Magento\ConfigurableProduct\Model\ResourceModel\Product\Type\Configurable $configurableProduct,
        \Magento\Store\Model\StoreManagerInterface $_storemanager,
        array $data = []
    ) {
        $this->_storemanager = $_storemanager;
        $this->_logger = $loggerProvider->getLogger();
        parent::__construct($context, $registry, $helper_product, $loggerProvider, $categoryFactory, $productFactory, $configurableProduct, $data);
    }

    /**
     * @param $product \Magento\Catalog\Model\Product
     * @param $value
     * @param $storeId
     * @return bool
     */
    public function process($product, $value, $storeId)
    {

        $this->_logger->addInfo("Processing Action addtodefaultcategory for product: " . $product -> getId());

        $storeManager = $this->_storemanager;
        $stores = $storeManager->getStores();

        // For each store, get default category
        $default_categories = array();
        /** @var $store \Magento\Store\Model\Store */
        foreach ($stores as $store) {
            $default_categories[] = $store -> getRootCategoryId();
        }

        // Filter categories
        $default_categories = array_unique(array_filter($default_categories));

        // Workaround on Addtocategory
        if(count($default_categories) == 1) {
            $default_categories[] = $default_categories[0];
        }

        // Create list of category ids
        if($default_categories) {
            $value = implode("|", $default_categories);

            // Set value as $rootCatId | $rootCatId as workaround on Addtocategory
            $this->_logger->addInfo("Processing Action addtodefaultcategory: " . $value);
            $return = parent::process($product, $value, $storeId); //
            $this->_logger->addInfo("Processed Action with result: " . print_r( $return, true ));
            return $return;

        } else {
            $this->_logger->addError("No root categories configured on stores");
            return false;
        }

    }

}